unit unitmain;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ComCtrls, VCLTee.TeEngine,
  VCLTee.Series, VCLTee.TeeProcs, VCLTee.Chart, Vcl.StdCtrls, Vcl.ExtCtrls, CameraDefs;

Const MAX_BUFFER_SIZE = 8192;
      NUMBER_OF_PIXEL = 102;

      fgain : array[0..31] of single =
      (
        1.00, 1.02, 1.05, 1.07, 1.09, 1.12, 1.15, 1.18, 1.21, 1.24, 1.27, 1.31,
        1.34, 1.38, 1.43, 1.47, 1.52, 1.57, 1.62, 1.68, 1.74, 1.81, 1.88, 1.96,
        2.05, 2.14, 2.24, 2.35, 2.48, 2.61, 2.77, 2.94
      );
      strgain : array[0..31] of String =
      (
        '1.00', '1.02', '1.05', '1.07', '1.09', '1.12', '1.15', '1.18', '1.21',
        '1.24', '1.27', '1.31', '1.34', '1.38', '1.43', '1.47', '1.52', '1.57',
        '1.62', '1.68', '1.74', '1.81', '1.88', '1.96', '2.05', '2.14', '2.24',
        '2.35', '2.48', '2.61', '2.77', '2.94'
      );
type

  TCCDThread = class(TThread)
  private
    fps : dword;
    usedmem : dword;
    CamData  : array[0..MAX_BUFFER_SIZE-1] of Byte;
    FCCDRead : DWORD;
    procedure UpDateChart;
  protected
    procedure Execute; override;
  public
    FActive  : Boolean;
    FTimeOut : DWORD;
    FRefreshRate : DWORD;
  end;

  Tfmmain = class(TForm)
    Panel1: TPanel;
    btn_enum: TButton;
    cb_devices: TComboBox;
    btn_opendevice: TButton;
    btn_info: TButton;
    btn_start: TButton;
    StatusBar1: TStatusBar;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    Chart1: TChart;
    Series1: TLineSeries;
    Panel2: TPanel;
    PageControl2: TPageControl;
    Cam: TTabSheet;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    lb_gain: TLabel;
    Label5: TLabel;
    lb_offset: TLabel;
    cb_mode: TComboBox;
    btn_exptime: TButton;
    ed_exptime: TEdit;
    tb_gain: TTrackBar;
    tb_offset: TTrackBar;
    btn_savesettings: TButton;
    GroupBox6: TGroupBox;
    btn_setcfg: TButton;
    TabSheet3: TTabSheet;
    Label19: TLabel;
    Label20: TLabel;
    ed_eptimeout: TEdit;
    ed_packetmultiplier: TEdit;
    btn_setep: TButton;
    Screen: TTabSheet;
    Label23: TLabel;
    lb_refreshrate: TLabel;
    tb_refreshrate: TTrackBar;
    Label26: TLabel;
    ed_numframes: TEdit;
    ud_numframes: TUpDown;
    procedure btn_infoClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btn_enumClick(Sender: TObject);
    procedure cb_devicesChange(Sender: TObject);
    procedure btn_opendeviceClick(Sender: TObject);
    procedure cb_modeChange(Sender: TObject);
    procedure btn_exptimeClick(Sender: TObject);
    procedure tb_gainChange(Sender: TObject);
    procedure tb_offsetChange(Sender: TObject);
    procedure btn_savesettingsClick(Sender: TObject);
    procedure btn_setepClick(Sender: TObject);
    procedure tb_refreshrateChange(Sender: TObject);
    procedure btn_setcfgClick(Sender: TObject);
    procedure ud_numframesChangingEx(Sender: TObject; var AllowChange: Boolean;
      NewValue: SmallInt; Direction: TUpDownDirection);
    procedure btn_startClick(Sender: TObject);
  private
    { Private-Deklarationen }
    dwpacketlength : dword;
  public
    { Public-Deklarationen }
    procedure to_statusbar(stxt : String);
    function formatmem(mem : dword) : string;
    procedure initchart;
    procedure closeusbdevice;
    procedure openusbdevice(idx : integer);
    function StartCCDThread : Boolean;
    procedure TerminateCCDThread;
    procedure WaitForCCDThread;
    procedure SyncParam;
    function geterrorstring(dwerr : dword) : String;
  end;

var
  fmmain: Tfmmain;
  dwPrivateMsg    : DWORD;
  CCDThreadReader : TCCDThread;

  PACKETLENGTH_MULTIPLIER : Byte;
  EndpointTimeout : DWORD;

implementation

{$R *.dfm}

uses UnitInfo;

{ TCCDThread }

procedure TCCDThread.Execute;
var dwErr, mem, bytestoread, bytesread, idx, imagesize : DWORD;
    tick1, tick2 : DWORD;
begin
  FRefreshRate := 100;
  tick1 := gettickcount;
  FActive := true;
  imagesize := NUMBER_OF_PIXEL;

  while not Terminated do
  begin
    bytestoread := imagesize;
    idx := 0;
    FCCDRead := 0;
    while (FCCDRead < imagesize) do
    begin
      dwerr := ls_getpipe(@CamData[idx],bytestoread,bytesread);
      if (dwerr = 0) then
      begin
        if bytesread < imagesize then
        begin
          idx := bytesread;
          bytestoread := bytestoread - bytesread;
        end;
        FCCDRead := FCCDRead + bytesread;
      end else
      begin
        if (dwErr = ERROR_BROKEN_PIPE) or (dwErr = ERROR_INVALID_HANDLE) then
          break;
      end;
    end;

    if FCCDRead > 0 then
    begin
      tick2 := GetTickCount;
      if (tick2 - tick1) > FRefreshRate then
      begin
        fps := round(ls_getfps / imagesize);
        if ls_getpipe(nil,0,mem) = 0 then usedmem := mem
        else usedmem := 0;

        tick1 := tick2;
        Synchronize(UpdateChart);
      end;
    end
  end;
  FActive := false;
end;

procedure TCCDThread.UpDateChart;
var i : word;
begin
  FRefreshRate := fmMain.tb_refreshrate.Position;
  fmMain.StatusBar1.Panels[1].Text := IntToStr(fps);
  fmMain.StatusBar1.Panels[2].Text := fmMain.formatmem(usedmem);

  for i := 0 to FCCDRead -1 do
    fmMain.Series1.YValues.Value[i] := CamData[i];

  fmMain.Series1.YValues.Modified := true;
  fmMain.Series1.Repaint;

  if fmMain.cb_mode.ItemIndex = 0 then
  begin
    fmMain.btn_start.Tag := 0;
    fmMain.btn_start.Caption := 'Start';
  end;
  fmMain.Update;
end;

{ Tfmmain }

procedure Tfmmain.TerminateCCDThread;
begin
  if (CCDThreadReader <> nil) and (CCDThreadReader.FActive) then
    CCDThreadReader.Terminate;
end;

procedure Tfmmain.WaitForCCDThread;
begin
  if (CCDThreadReader <> nil) then
  begin
    CCDThreadReader.WaitFor;
    CCDThreadReader := nil;
  end;
end;

function Tfmmain.geterrorstring(dwerr : dword) : String;
begin
  Result := String(ls_geterrorstring(dwerr));
end;

function Tfmmain.formatmem(mem : dword) : string;
begin
  if mem > (1024 * 1024) then
  begin
    Result := IntToStr(round(mem / (1024 * 1024))) + ' MB';
  end else if mem > 1024 then
  begin
    Result := IntToStr(round(mem / 1024)) + ' kB';
  end else begin
    Result := IntToStr(mem) + ' Bytes';
  end;
end;

procedure Tfmmain.ud_numframesChangingEx(Sender: TObject;
  var AllowChange: Boolean; NewValue: SmallInt; Direction: TUpDownDirection);
begin
  if (NewValue < 1) or (NewValue > 16) then
 begin
   AllowChange := false;
 end;
end;

procedure Tfmmain.btn_exptimeClick(Sender: TObject);
var dwErr : DWORD;
    dwexptime : DWORD;
begin
  dwexptime := StrToIntDef(ed_exptime.Text,10000);
  ed_exptime.Text := IntToStr(dwexptime);
  dwErr := ls_setinttime(dwexptime);
  to_statusbar('SET INT TIME: '+ls_geterrorstring(dwerr));
end;

procedure Tfmmain.btn_infoClick(Sender: TObject);
begin
  fmInfo.ShowModal;
end;

procedure Tfmmain.btn_savesettingsClick(Sender: TObject);
begin
  to_statusbar(geterrorstring(ls_savesettings));
end;

procedure Tfmmain.btn_setcfgClick(Sender: TObject);
var dwErr : DWORD;
    uccfg1 : byte;
begin
  uccfg1 := ((ud_numframes.Position-1) and $0F);
  dwErr := ls_setcfg1(uccfg1);
  if dwErr = RET_OK then
  begin
    Showmessage('Changes takes effect after reboot - Power OFF/ON');
  end;
  to_statusbar('SET CFG1: '+ls_geterrorstring(dwerr));
end;

procedure Tfmmain.btn_setepClick(Sender: TObject);
var eptimeout : dword;
begin
  eptimeout := StrToIntDef(ed_eptimeout.Text,0);
  ed_eptimeout.Text := IntToStr(eptimeout);
  to_statusbar(geterrorstring(ls_seteptimeout(eptimeout)));

  PACKETLENGTH_MULTIPLIER := StrToIntDef(ed_packetmultiplier.Text,1);
  if PACKETLENGTH_MULTIPLIER < 1 then PACKETLENGTH_MULTIPLIER := 1;
  ed_packetmultiplier.Text := IntToStr(PACKETLENGTH_MULTIPLIER);
end;

procedure Tfmmain.btn_startClick(Sender: TObject);
var dwErr : DWORD;
begin
  btn_start.Tag := (not btn_start.Tag) and $01;
  dwErr := ls_setstate(btn_start.Tag);
  if dwErr = RET_OK then
  begin
    if btn_Start.Tag = $01 then btn_Start.Caption := 'Stop'
    else btn_Start.Caption := 'Start';
  end else btn_start.Tag := (not btn_start.Tag) and $01;
  to_statusbar('SET STATE: '+ls_geterrorstring(dwerr));
end;

procedure Tfmmain.cb_modeChange(Sender: TObject);
var dwerr : DWORD;
begin
  dwerr := ls_setmode(cb_mode.ItemIndex);
  if dwerr = RET_OK then
  begin
    if cb_mode.ItemIndex = 0 then
    begin
      btn_start.Tag := 0;
      btn_start.Caption := 'Start';
    end;
  end;
  to_statusbar('SET MODE: '+ls_geterrorstring(dwerr));
end;

procedure Tfmmain.cb_devicesChange(Sender: TObject);
begin
  openusbdevice(cb_devices.ItemIndex);
end;

procedure Tfmmain.closeusbdevice;
begin
  TerminateCCDThread;
  ls_closedevice;
  WaitForCCDThread;
  btn_opendevice.Caption := 'Open Device';
  to_statusbar('USB DEVICE CLOSED');
end;

procedure Tfmmain.openusbdevice(idx: integer);
var tmp_length : dword;
begin
  if (cb_devices.Items.Count = 0) or (idx < 0) then exit;

  if ls_currentdeviceindex > -1 then
  begin
    closeusbdevice;
  end else
  begin
    if  ls_opendevicebyindex(idx) = RET_OK then
    begin
      ls_setstate(0);
      if ls_getpacketlength(tmp_length) = RET_OK then
      begin
        if tmp_length <> (dwpacketlength DIV PACKETLENGTH_MULTIPLIER) then
        begin
          closeusbdevice;
          dwpacketlength := tmp_length * PACKETLENGTH_MULTIPLIER;
          if ls_setpacketlength(dwpacketlength) = RET_OK then
            ls_opendevicebyindex(idx);
        end;
      end;
    end;
    if ls_currentdeviceindex >= 0 then
    begin
      SyncParam;
      StartCCDThread;
      btn_opendevice.Caption := 'Close Device';
      to_statusbar('USB DEVICE OPEN')
    end;
  end;
end;

procedure Tfmmain.btn_opendeviceClick(Sender: TObject);
begin
  openusbdevice(cb_devices.ItemIndex);
end;

procedure Tfmmain.btn_enumClick(Sender: TObject);
var Cnt, i : ShortInt;
begin
  cb_devices.Clear;

  if ls_currentdeviceindex > -1 then
    closeusbdevice;

  Cnt := ls_enumdevices;

  to_statusbar(IntToStr(Cnt)+' device(s) found');
  if Cnt > 0 then
  begin
    for i := 0 to Cnt - 1 do
      cb_devices.Items.Add(String(ls_getproductname(i))+' '+String(ls_getserialnumber(i)));

    cb_devices.ItemIndex := 0;
    openusbdevice(cb_devices.ItemIndex);
  end else to_statusbar('NO USB DEVICES ATTACHED!');
end;

procedure Tfmmain.initchart;
var i : integer;
begin
  Series1.Clear;
  Chart1.BottomAxis.SetMinMax(0,NUMBER_OF_PIXEL-1);
  Chart1.LeftAxis.SetMinMax(0,255);
  for i := 0 to NUMBER_OF_PIXEL-1 do
    Series1.AddXY(i,0);
end;

procedure Tfmmain.FormCreate(Sender: TObject);
begin
{$IFDEF WIN32}
  Caption := 'TinyUSB Line Camera 3301 - Delphi Example (32Bit)';
{$ELSE}
  Caption := 'TinyUSB Line Camera 3301 - Delphi Example (64Bit)';
{$ENDIF}
  PACKETLENGTH_MULTIPLIER := 1;
  EndpointTimeout := 100; // 100 ms

  dwpacketlength := NUMBER_OF_PIXEL * PACKETLENGTH_MULTIPLIER;
  initchart;
  cb_mode.ItemIndex := 2;

  ls_seteptimeout(EndpointTimeout);
  dwPrivateMsg := ls_initialize(_64MB,dwpacketlength,NORMAL_PRIORITY_CLASS, THREAD_PRIORITY_ABOVE_NORMAL, 'CX_TINYUSB_LINE_CAMERA');
  if dwPrivateMsg <> 0 then to_statusbar('APPLICATION INITIALIZED');
end;

function Tfmmain.StartCCDThread: Boolean;
begin
  Result := true;
  CCDThreadReader := TCCDThread.Create(True);
  CCDThreadReader.Priority := tpHighest;
  CCDThreadReader.FreeOnTerminate := false;
  CCDThreadReader.FActive := false;
  CCDThreadReader.FTimeOut := _1S;
  CCDThreadReader.Start;
end;

procedure Tfmmain.SyncParam;
Var dwErr : DWORD;
    dwValue : DWORD;
    ucval1, ucval2, ucval3 : byte;
    cval : shortint;
begin

  dwErr := ls_getgain(ucval1,ucval2,ucval3);
  if dwErr = RET_OK then
  begin
    tb_gain.OnChange := nil;
    tb_gain.Position := ucval1;
    lb_gain.caption  := strgain[ucval1];
    tb_gain.OnChange := tb_gainChange;
  end;

  dwErr := ls_getoffset(ucval1,ucval2,ucval3);
  if dwErr = RET_OK then
  begin
    tb_offset.OnChange := nil;

    if ucval1 >= $80 then
    begin
      cval := -1 * (ucval1 - $7F);
    end else cval := ucval1;

    tb_offset.position := cval;
    lb_offset.caption := IntToStr(tb_offset.position);
    tb_offset.OnChange := tb_offsetChange;
  end;

  dwErr := ls_getinttime(dwvalue);
  if dwErr = RET_OK then
    ed_exptime.Text := IntToStr(dwvalue);

  dwErr := ls_getstate(ucval1);
  if dwErr = RET_OK then
  begin
    btn_start.Tag := ucval1;
    if btn_start.tag = 0 then btn_start.caption := 'Start'
    else btn_start.caption := 'Stop';
  end;

  dwErr := ls_getmode(ucval1);
  if dwErr = RET_OK then
  begin
    cb_mode.OnChange := nil;
    cb_mode.ItemIndex := ucval1 and $03;
    cb_mode.OnChange := cb_modeChange;
  end;

  dwErr := ls_getcfg1(ucval1);
  if dwErr = RET_OK then
  begin
    ud_numframes.Position := (ucval1 and $0F)+1;
  end;
end;

procedure Tfmmain.tb_gainChange(Sender: TObject);
var dwerr : dword;
    ucgain : byte;
begin
  ucgain := tb_gain.Position;
  lb_gain.Caption := strgain[ucgain];
  dwerr := ls_setgain(ucgain,ucgain,ucgain);
  to_statusbar('SET GAIN: '+ls_geterrorstring(dwerr));
end;

procedure Tfmmain.tb_offsetChange(Sender: TObject);
var dwerr  : dword;
    ucoffset : byte;
begin
  lb_offset.caption := IntToStr(tb_offset.position);
  if tb_offset.position < 0 then
  begin
    ucoffset := abs(tb_offset.position);
    ucoffset := ucoffset + $7F;
    lb_offset.caption := IntToStr(tb_offset.position);
  end else ucoffset := tb_offset.position;
  dwerr := ls_setoffset(ucoffset,ucoffset,ucoffset);
  to_statusbar('SET OFFSET: '+ls_geterrorstring(dwerr));
end;

procedure Tfmmain.tb_refreshrateChange(Sender: TObject);
begin
  lb_refreshrate.Caption := IntToStr(tb_refreshrate.Position);
end;

procedure Tfmmain.to_statusbar(stxt: String);
begin
  StatusBar1.Panels[0].Text := stxt;
end;

end.
